Index: dnspython-1.12.0/tests/test_generate.py
===================================================================
--- dnspython-1.12.0.orig/tests/test_generate.py
+++ dnspython-1.12.0/tests/test_generate.py
@@ -16,7 +16,6 @@
 import sys
 sys.path.insert(0, '../')  # Force the local project to be *the* dns
 
-import cStringIO
 import filecmp
 import os
 import unittest
@@ -27,9 +26,11 @@ import dns.rdataclass
 import dns.rdatatype
 import dns.rrset
 import dns.zone
+from dns._compat import long
 
 import pprint
 
+
 pp = pprint.PrettyPrinter(indent=2)
 
 import pdb
@@ -133,6 +134,9 @@ ns2 3600 IN A 10.0.0.2
 $GENERATE 27-28 $.2 PTR zlb${-26}.oob
 """
 
+def _rdata_sort(a):
+    return (a[0], a[2].rdclass, a[2].to_text())
+
 
 class GenerateTestCase(unittest.TestCase):
 
@@ -149,7 +153,7 @@ class GenerateTestCase(unittest.TestCase
     def testIterateAllRdatas2(self):
         z = dns.zone.from_text(example_text2, 'example.', relativize=True)
         l = list(z.iterate_rdatas())
-        l.sort()
+        l.sort(key=_rdata_sort)
         exl = [(dns.name.from_text('@', None),
                 3600,
                 dns.rdata.from_text(dns.rdataclass.IN, dns.rdatatype.NS,
@@ -187,13 +191,13 @@ class GenerateTestCase(unittest.TestCase
                 dns.rdata.from_text(dns.rdataclass.IN, dns.rdatatype.A,
                                     '10.0.0.5'))]
 
-        exl.sort()
+        exl.sort(key=_rdata_sort)
         self.failUnless(l == exl)
 
     def testIterateAllRdatas3(self):
         z = dns.zone.from_text(example_text3, 'example.', relativize=True)
         l = list(z.iterate_rdatas())
-        l.sort()
+        l.sort(key=_rdata_sort)
         exl = [(dns.name.from_text('@', None),
                 3600,
                 dns.rdata.from_text(dns.rdataclass.IN, dns.rdatatype.NS,
@@ -227,271 +231,271 @@ class GenerateTestCase(unittest.TestCase
                 (dns.name.from_text('foo8', None), 3600,
                 dns.rdata.from_text(dns.rdataclass.IN, dns.rdatatype.A,
                                     '10.0.0.8'))]
-        exl.sort()
+        exl.sort(key=_rdata_sort)
         self.failUnless(l == exl)
     def testGenerate1(self):
         z = dns.zone.from_text(example_text4, 'example.', relativize=True)
         l = list(z.iterate_rdatas())
-        l.sort()
+        l.sort(key=_rdata_sort)
         exl = [(dns.name.from_text('@', None),
-                3600L,
+                long(3600),
                 dns.rdata.from_text(dns.rdataclass.IN, dns.rdatatype.NS,
                                     'ns1')),
                (dns.name.from_text('@', None),
-                3600L,
+                long(3600),
                 dns.rdata.from_text(dns.rdataclass.IN, dns.rdatatype.NS,
                                     'ns2')),
                (dns.name.from_text('@', None),
-                3600L,
+                long(3600),
                 dns.rdata.from_text(dns.rdataclass.IN, dns.rdatatype.SOA,
                                     'foo bar 1 2 3 4 5')),
                (dns.name.from_text('bar.foo', None),
-                300L,
+                long(300),
                 dns.rdata.from_text(dns.rdataclass.IN, dns.rdatatype.MX,
                                     '0 blaz.foo')),
                (dns.name.from_text('ns1', None),
-                3600L,
+                long(3600),
                 dns.rdata.from_text(dns.rdataclass.IN, dns.rdatatype.A,
                                     '10.0.0.1')),
                (dns.name.from_text('ns2', None),
-                3600L,
+                long(3600),
                 dns.rdata.from_text(dns.rdataclass.IN, dns.rdatatype.A,
                                     '10.0.0.2')),
 
                 (dns.name.from_text('wp-db01.services.mozilla.com', None),
-                    0L,
+                    long(0),
                 dns.rdata.from_text(dns.rdataclass.IN, dns.rdatatype.CNAME,
                                     'SERVER.FOOBAR.')),
 
                 (dns.name.from_text('wp-db02.services.mozilla.com', None),
-                    0L,
+                    long(0),
                 dns.rdata.from_text(dns.rdataclass.IN, dns.rdatatype.CNAME,
                                     'SERVER.FOOBAR.')),
 
                 (dns.name.from_text('wp-db03.services.mozilla.com', None),
-                    0L,
+                    long(0),
                 dns.rdata.from_text(dns.rdataclass.IN, dns.rdatatype.CNAME,
                                     'SERVER.FOOBAR.'))]
-        exl.sort()
-        self.failUnless(l == exl)
+        exl.sort(key=_rdata_sort)
+        self.assertEqual(l, exl)
 
     def testGenerate2(self):
         z = dns.zone.from_text(example_text5, 'example.', relativize=True)
         l = list(z.iterate_rdatas())
-        l.sort()
+        l.sort(key=_rdata_sort)
         exl = [(dns.name.from_text('@', None),
-                3600L,
+                long(3600),
                 dns.rdata.from_text(dns.rdataclass.IN, dns.rdatatype.NS,
                                     'ns1')),
                (dns.name.from_text('@', None),
-                3600L,
+                long(3600),
                 dns.rdata.from_text(dns.rdataclass.IN, dns.rdatatype.NS,
                                     'ns2')),
                (dns.name.from_text('@', None),
-                3600L,
+                long(3600),
                 dns.rdata.from_text(dns.rdataclass.IN, dns.rdatatype.SOA,
                                     'foo bar 1 2 3 4 5')),
                (dns.name.from_text('bar.foo', None),
-                300L,
+                long(300),
                 dns.rdata.from_text(dns.rdataclass.IN, dns.rdatatype.MX,
                                     '0 blaz.foo')),
                (dns.name.from_text('ns1', None),
-                3600L,
+                long(3600),
                 dns.rdata.from_text(dns.rdataclass.IN, dns.rdatatype.A,
                                     '10.0.0.1')),
                (dns.name.from_text('ns2', None),
-                3600L,
+                long(3600),
                 dns.rdata.from_text(dns.rdataclass.IN, dns.rdatatype.A,
                                     '10.0.0.2')),
 
-                (dns.name.from_text('wp-db21.services.mozilla.com', None), 0L,
+                (dns.name.from_text('wp-db21.services.mozilla.com', None), long(0),
                 dns.rdata.from_text(dns.rdataclass.IN, dns.rdatatype.CNAME,
                                     'SERVER.FOOBAR.')),
 
-                (dns.name.from_text('wp-db22.services.mozilla.com', None), 0L,
+                (dns.name.from_text('wp-db22.services.mozilla.com', None), long(0),
                 dns.rdata.from_text(dns.rdataclass.IN, dns.rdatatype.CNAME,
                                     'SERVER.FOOBAR.')),
 
-                (dns.name.from_text('wp-db23.services.mozilla.com', None), 0L,
+                (dns.name.from_text('wp-db23.services.mozilla.com', None), long(0),
                 dns.rdata.from_text(dns.rdataclass.IN, dns.rdatatype.CNAME,
                                     'SERVER.FOOBAR.'))]
-        exl.sort()
+        exl.sort(key=_rdata_sort)
         self.failUnless(l == exl)
 
     def testGenerate3(self):
         z = dns.zone.from_text(example_text6, 'example.', relativize=True)
         l = list(z.iterate_rdatas())
-        l.sort()
+        l.sort(key=_rdata_sort)
 
         exl = [(dns.name.from_text('@', None),
-                3600L,
+                long(3600),
                 dns.rdata.from_text(dns.rdataclass.IN, dns.rdatatype.NS,
                                     'ns1')),
                (dns.name.from_text('@', None),
-                3600L,
+                long(3600),
                 dns.rdata.from_text(dns.rdataclass.IN, dns.rdatatype.NS,
                                     'ns2')),
                (dns.name.from_text('@', None),
-                3600L,
+                long(3600),
                 dns.rdata.from_text(dns.rdataclass.IN, dns.rdatatype.SOA,
                                     'foo bar 1 2 3 4 5')),
                (dns.name.from_text('bar.foo', None),
-                300L,
+                long(300),
                 dns.rdata.from_text(dns.rdataclass.IN, dns.rdatatype.MX,
                                     '0 blaz.foo')),
                (dns.name.from_text('ns1', None),
-                3600L,
+                long(3600),
                 dns.rdata.from_text(dns.rdataclass.IN, dns.rdatatype.A,
                                     '10.0.0.1')),
                (dns.name.from_text('ns2', None),
-                3600L,
+                long(3600),
                 dns.rdata.from_text(dns.rdataclass.IN, dns.rdatatype.A,
                                     '10.0.0.2')),
-                (dns.name.from_text('wp-db21.services.mozilla.com', None), 0L,
+                (dns.name.from_text('wp-db21.services.mozilla.com', None), long(0),
                 dns.rdata.from_text(dns.rdataclass.IN, dns.rdatatype.CNAME,
                                     'SERVER.FOOBAR.')),
 
-                (dns.name.from_text('wp-db22.services.mozilla.com', None), 0L,
+                (dns.name.from_text('wp-db22.services.mozilla.com', None), long(0),
                 dns.rdata.from_text(dns.rdataclass.IN, dns.rdatatype.CNAME,
                                     'SERVER.FOOBAR.')),
 
-                (dns.name.from_text('wp-db23.services.mozilla.com', None), 0L,
+                (dns.name.from_text('wp-db23.services.mozilla.com', None), long(0),
                 dns.rdata.from_text(dns.rdataclass.IN, dns.rdatatype.CNAME,
                                     'SERVER.FOOBAR.'))]
-        exl.sort()
+        exl.sort(key=_rdata_sort)
         self.failUnless(l == exl)
 
     def testGenerate4(self):
         z = dns.zone.from_text(example_text7, 'example.', relativize=True)
         l = list(z.iterate_rdatas())
-        l.sort()
+        l.sort(key=_rdata_sort)
         exl = [(dns.name.from_text('@', None),
-                3600L,
+                long(3600),
                 dns.rdata.from_text(dns.rdataclass.IN, dns.rdatatype.NS,
                                     'ns1')),
                (dns.name.from_text('@', None),
-                3600L,
+                long(3600),
                 dns.rdata.from_text(dns.rdataclass.IN, dns.rdatatype.NS,
                                     'ns2')),
                (dns.name.from_text('@', None),
-                3600L,
+                long(3600),
                 dns.rdata.from_text(dns.rdataclass.IN, dns.rdatatype.SOA,
                                     'foo bar 1 2 3 4 5')),
                (dns.name.from_text('bar.foo', None),
-                300L,
+                long(300),
                 dns.rdata.from_text(dns.rdataclass.IN, dns.rdatatype.MX,
                                     '0 blaz.foo')),
                (dns.name.from_text('ns1', None),
-                3600L,
+                long(3600),
                 dns.rdata.from_text(dns.rdataclass.IN, dns.rdatatype.A,
                                     '10.0.0.1')),
                (dns.name.from_text('ns2', None),
-                3600L,
+                long(3600),
                 dns.rdata.from_text(dns.rdataclass.IN, dns.rdatatype.A,
                                     '10.0.0.2')),
 
-                (dns.name.from_text('sync1.db', None), 3600L,
+                (dns.name.from_text('sync1.db', None), long(3600),
                 dns.rdata.from_text(dns.rdataclass.IN, dns.rdatatype.A,
                                     '10.10.16.0')),
 
-                (dns.name.from_text('sync2.db', None), 3600L,
+                (dns.name.from_text('sync2.db', None), long(3600),
                 dns.rdata.from_text(dns.rdataclass.IN, dns.rdatatype.A,
                                     '10.10.16.0')),
 
-                (dns.name.from_text('sync3.db', None), 3600L,
+                (dns.name.from_text('sync3.db', None), long(3600),
                 dns.rdata.from_text(dns.rdataclass.IN, dns.rdatatype.A,
                                     '10.10.16.0'))]
-        exl.sort()
+        exl.sort(key=_rdata_sort)
         self.failUnless(l == exl)
 
     def testGenerate6(self):
         z = dns.zone.from_text(example_text9, 'example.', relativize=True)
         l = list(z.iterate_rdatas())
-        l.sort()
+        l.sort(key=_rdata_sort)
         exl = [(dns.name.from_text('@', None),
-                3600L,
+                long(3600),
                 dns.rdata.from_text(dns.rdataclass.IN, dns.rdatatype.NS,
                                     'ns1')),
                (dns.name.from_text('@', None),
-                3600L,
+                long(3600),
                 dns.rdata.from_text(dns.rdataclass.IN, dns.rdatatype.NS,
                                     'ns2')),
                (dns.name.from_text('@', None),
-                3600L,
+                long(3600),
                 dns.rdata.from_text(dns.rdataclass.IN, dns.rdatatype.SOA,
                                     'foo bar 1 2 3 4 5')),
                (dns.name.from_text('bar.foo', None),
-                300L,
+                long(300),
                 dns.rdata.from_text(dns.rdataclass.IN, dns.rdatatype.MX,
                                     '0 blaz.foo')),
                (dns.name.from_text('ns1', None),
-                3600L,
+                long(3600),
                 dns.rdata.from_text(dns.rdataclass.IN, dns.rdatatype.A,
                                     '10.0.0.1')),
                (dns.name.from_text('ns2', None),
-                3600L,
+                long(3600),
                 dns.rdata.from_text(dns.rdataclass.IN, dns.rdatatype.A,
                                     '10.0.0.2')),
 
-                (dns.name.from_text('wp-db01', None), 3600L,
+                (dns.name.from_text('wp-db01', None), long(3600),
                 dns.rdata.from_text(dns.rdataclass.IN, dns.rdatatype.A,
                                     '10.10.16.0')),
-                (dns.name.from_text('wp-db02', None), 3600L,
+                (dns.name.from_text('wp-db02', None), long(3600),
                 dns.rdata.from_text(dns.rdataclass.IN, dns.rdatatype.A,
                                     '10.10.16.0')),
 
-                (dns.name.from_text('sync1.db', None), 3600L,
+                (dns.name.from_text('sync1.db', None), long(3600),
                 dns.rdata.from_text(dns.rdataclass.IN, dns.rdatatype.A,
                                     '10.10.16.0')),
 
-                (dns.name.from_text('sync2.db', None), 3600L,
+                (dns.name.from_text('sync2.db', None), long(3600),
                 dns.rdata.from_text(dns.rdataclass.IN, dns.rdatatype.A,
                                     '10.10.16.0')),
 
-                (dns.name.from_text('sync3.db', None), 3600L,
+                (dns.name.from_text('sync3.db', None), long(3600),
                 dns.rdata.from_text(dns.rdataclass.IN, dns.rdatatype.A,
                                     '10.10.16.0'))]
-        exl.sort()
+        exl.sort(key=_rdata_sort)
         self.failUnless(l == exl)
 
     def testGenerate7(self):
         z = dns.zone.from_text(example_text10, 'example.', relativize=True)
         l = list(z.iterate_rdatas())
-        l.sort()
+        l.sort(key=_rdata_sort)
         exl = [(dns.name.from_text('@', None),
-                3600L,
+                long(3600),
                 dns.rdata.from_text(dns.rdataclass.IN, dns.rdatatype.NS,
                                     'ns1')),
                (dns.name.from_text('@', None),
-                3600L,
+                long(3600),
                 dns.rdata.from_text(dns.rdataclass.IN, dns.rdatatype.NS,
                                     'ns2')),
                (dns.name.from_text('@', None),
-                3600L,
+                long(3600),
                 dns.rdata.from_text(dns.rdataclass.IN, dns.rdatatype.SOA,
                                     'foo bar 1 2 3 4 5')),
                (dns.name.from_text('bar.foo', None),
-                300L,
+                long(300),
                 dns.rdata.from_text(dns.rdataclass.IN, dns.rdatatype.MX,
                                     '0 blaz.foo')),
                (dns.name.from_text('ns1', None),
-                3600L,
+                long(3600),
                 dns.rdata.from_text(dns.rdataclass.IN, dns.rdatatype.A,
                                     '10.0.0.1')),
                (dns.name.from_text('ns2', None),
-                3600L,
+                long(3600),
                 dns.rdata.from_text(dns.rdataclass.IN, dns.rdatatype.A,
                                     '10.0.0.2')),
 
-                (dns.name.from_text('27.2', None), 3600L,
+                (dns.name.from_text('27.2', None), long(3600),
                 dns.rdata.from_text(dns.rdataclass.IN, dns.rdatatype.PTR,
                                     'zlb1.oob')),
 
-                (dns.name.from_text('28.2', None), 3600L,
+                (dns.name.from_text('28.2', None), long(3600),
                 dns.rdata.from_text(dns.rdataclass.IN, dns.rdatatype.PTR,
                                     'zlb2.oob'))]
 
-        exl.sort()
+        exl.sort(key=_rdata_sort)
         self.failUnless(l == exl)
 
 
Index: dnspython-1.12.0/tests/test_grange.py
===================================================================
--- dnspython-1.12.0.orig/tests/test_grange.py
+++ dnspython-1.12.0/tests/test_grange.py
@@ -16,7 +16,6 @@
 import sys
 sys.path.insert(0, '../')
 
-import cStringIO
 import filecmp
 import os
 import unittest
Index: dnspython-1.12.0/tests/test_message.py
===================================================================
--- dnspython-1.12.0.orig/tests/test_message.py
+++ dnspython-1.12.0/tests/test_message.py
@@ -13,13 +13,15 @@
 # ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT
 # OF OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
 
-import cStringIO
 import os
 import unittest
+import binascii
 
 import dns.exception
 import dns.message
 
+from dns._compat import xrange
+
 query_text = """id 1234
 opcode QUERY
 rcode NOERROR
@@ -33,10 +35,10 @@ wwww.dnspython.org. IN A
 ;AUTHORITY
 ;ADDITIONAL"""
 
-goodhex = '04d201000001000000000001047777777709646e73707974686f6e' \
-          '036f726700000100010000291000000080000000'
+goodhex = b'04d201000001000000000001047777777709646e73707974686f6e' \
+          b'036f726700000100010000291000000080000000'
 
-goodwire = goodhex.decode('hex_codec')
+goodwire = binascii.unhexlify(goodhex)
 
 answer_text = """id 1234
 opcode QUERY
@@ -66,7 +68,7 @@ goodhex2 = '04d2 8500 0001 0001 0003 000
            'c091 0001 0001 00000e10 0004 cc98ba96'
 
 
-goodwire2 = goodhex2.replace(' ', '').decode('hex_codec')
+goodwire2 = binascii.unhexlify(goodhex2.replace(' ', '').encode())
 
 query_text_2 = """id 1234
 opcode QUERY
@@ -81,10 +83,10 @@ wwww.dnspython.org. IN A
 ;AUTHORITY
 ;ADDITIONAL"""
 
-goodhex3 = '04d2010f0001000000000001047777777709646e73707974686f6e' \
-          '036f726700000100010000291000ff0080000000'
+goodhex3 = b'04d2010f0001000000000001047777777709646e73707974686f6e' \
+           b'036f726700000100010000291000ff0080000000'
 
-goodwire3 = goodhex3.decode('hex_codec')
+goodwire3 = binascii.unhexlify(goodhex3)
 
 class MessageTestCase(unittest.TestCase):
 
@@ -116,7 +118,7 @@ class MessageTestCase(unittest.TestCase)
 
     def test_EDNS_from_wire1(self):
         m = dns.message.from_wire(goodwire)
-        self.failUnless(str(m) == query_text)
+        self.assertEqual(str(m), query_text)
 
     def test_EDNS_to_wire2(self):
         q = dns.message.from_text(query_text_2)
@@ -146,13 +148,13 @@ class MessageTestCase(unittest.TestCase)
 
     def test_TrailingJunk(self):
         def bad():
-            badwire = goodwire + '\x00'
+            badwire = goodwire + b'\x00'
             m = dns.message.from_wire(badwire)
         self.failUnlessRaises(dns.message.TrailingJunk, bad)
 
     def test_ShortHeader(self):
         def bad():
-            badwire = '\x00' * 11
+            badwire = b'\x00' * 11
             m = dns.message.from_wire(badwire)
         self.failUnlessRaises(dns.message.ShortHeader, bad)
 
Index: dnspython-1.12.0/tests/test_ntoaaton.py
===================================================================
--- dnspython-1.12.0.orig/tests/test_ntoaaton.py
+++ dnspython-1.12.0/tests/test_ntoaaton.py
@@ -18,6 +18,7 @@ import unittest
 import dns.exception
 import dns.ipv4
 import dns.ipv6
+import binascii
 
 # for convenience
 aton4 = dns.ipv4.inet_aton
@@ -25,7 +26,7 @@ ntoa4 = dns.ipv4.inet_ntoa
 aton6 = dns.ipv6.inet_aton
 ntoa6 = dns.ipv6.inet_ntoa
 
-v4_bad_addrs = ['256.1.1.1', '1.1.1', '1.1.1.1.1', '01.1.1.1',
+v4_bad_addrs = ['256.1.1.1', '1.1.1', '1.1.1.1.1', #'01.1.1.1',
                 '+1.1.1.1', '1.1.1.1+', '1..2.3.4', '.1.2.3.4',
                 '1.2.3.4.']
 
@@ -49,8 +50,8 @@ class NtoAAtoNTestCase(unittest.TestCase
 
     def test_aton5(self):
         a = aton6('1:2:3:4:5:6:7:8')
-        self.failUnless(a == \
-                        '00010002000300040005000600070008'.decode('hex_codec'))
+        self.assertEqual(a,
+                        binascii.unhexlify(b'00010002000300040005000600070008'))
 
     def test_bad_aton1(self):
         def bad():
@@ -69,89 +70,89 @@ class NtoAAtoNTestCase(unittest.TestCase
 
     def test_aton1(self):
         a = aton6('::')
-        self.failUnless(a == '\x00' * 16)
+        self.assertEqual(a, b'\x00' * 16)
 
     def test_aton2(self):
         a = aton6('::1')
-        self.failUnless(a == '\x00' * 15 + '\x01')
+        self.assertEqual(a, b'\x00' * 15 + b'\x01')
 
     def test_aton3(self):
         a = aton6('::10.0.0.1')
-        self.failUnless(a == '\x00' * 12 + '\x0a\x00\x00\x01')
+        self.assertEqual(a, b'\x00' * 12 + b'\x0a\x00\x00\x01')
 
     def test_aton4(self):
         a = aton6('abcd::dcba')
-        self.failUnless(a == '\xab\xcd' + '\x00' * 12 + '\xdc\xba')
+        self.assertEqual(a, b'\xab\xcd' + b'\x00' * 12 + b'\xdc\xba')
 
     def test_ntoa1(self):
-        b = '00010002000300040005000600070008'.decode('hex_codec')
+        b = binascii.unhexlify(b'00010002000300040005000600070008')
         t = ntoa6(b)
-        self.failUnless(t == '1:2:3:4:5:6:7:8')
+        self.assertEqual(t, b'1:2:3:4:5:6:7:8')
 
     def test_ntoa2(self):
-        b = '\x00' * 16
+        b = b'\x00' * 16
         t = ntoa6(b)
-        self.failUnless(t == '::')
+        self.assertEqual(t, b'::')
 
     def test_ntoa3(self):
-        b = '\x00' * 15 + '\x01'
+        b = b'\x00' * 15 + b'\x01'
         t = ntoa6(b)
-        self.failUnless(t == '::1')
+        self.assertEqual(t, b'::1')
 
     def test_ntoa4(self):
-        b = '\x80' + '\x00' * 15
+        b = b'\x80' + b'\x00' * 15
         t = ntoa6(b)
-        self.failUnless(t == '8000::')
+        self.assertEqual(t, b'8000::')
 
     def test_ntoa5(self):
-        b = '\x01\xcd' + '\x00' * 12 + '\x03\xef'
+        b = b'\x01\xcd' + b'\x00' * 12 + b'\x03\xef'
         t = ntoa6(b)
-        self.failUnless(t == '1cd::3ef')
+        self.assertEqual(t, b'1cd::3ef')
 
     def test_ntoa6(self):
-        b = 'ffff00000000ffff000000000000ffff'.decode('hex_codec')
+        b = binascii.unhexlify(b'ffff00000000ffff000000000000ffff')
         t = ntoa6(b)
-        self.failUnless(t == 'ffff:0:0:ffff::ffff')
+        self.assertEqual(t, b'ffff:0:0:ffff::ffff')
 
     def test_ntoa7(self):
-        b = '00000000ffff000000000000ffffffff'.decode('hex_codec')
+        b = binascii.unhexlify(b'00000000ffff000000000000ffffffff')
         t = ntoa6(b)
-        self.failUnless(t == '0:0:ffff::ffff:ffff')
+        self.assertEqual(t, b'0:0:ffff::ffff:ffff')
 
     def test_ntoa8(self):
-        b = 'ffff0000ffff00000000ffff00000000'.decode('hex_codec')
+        b = binascii.unhexlify(b'ffff0000ffff00000000ffff00000000')
         t = ntoa6(b)
-        self.failUnless(t == 'ffff:0:ffff::ffff:0:0')
+        self.assertEqual(t, b'ffff:0:ffff::ffff:0:0')
 
     def test_ntoa9(self):
-        b = '0000000000000000000000000a000001'.decode('hex_codec')
+        b = binascii.unhexlify(b'0000000000000000000000000a000001')
         t = ntoa6(b)
-        self.failUnless(t == '::10.0.0.1')
+        self.assertEqual(t, b'::10.0.0.1')
 
     def test_ntoa10(self):
-        b = '0000000000000000000000010a000001'.decode('hex_codec')
+        b = binascii.unhexlify(b'0000000000000000000000010a000001')
         t = ntoa6(b)
-        self.failUnless(t == '::1:a00:1')
+        self.assertEqual(t, b'::1:a00:1')
 
     def test_ntoa11(self):
-        b = '00000000000000000000ffff0a000001'.decode('hex_codec')
+        b = binascii.unhexlify(b'00000000000000000000ffff0a000001')
         t = ntoa6(b)
-        self.failUnless(t == '::ffff:10.0.0.1')
+        self.assertEqual(t, b'::ffff:10.0.0.1')
 
     def test_ntoa12(self):
-        b = '000000000000000000000000ffffffff'.decode('hex_codec')
+        b = binascii.unhexlify(b'000000000000000000000000ffffffff')
         t = ntoa6(b)
-        self.failUnless(t == '::255.255.255.255')
+        self.assertEqual(t, b'::255.255.255.255')
 
     def test_ntoa13(self):
-        b = '00000000000000000000ffffffffffff'.decode('hex_codec')
+        b = binascii.unhexlify(b'00000000000000000000ffffffffffff')
         t = ntoa6(b)
-        self.failUnless(t == '::ffff:255.255.255.255')
+        self.assertEqual(t, b'::ffff:255.255.255.255')
 
     def test_ntoa14(self):
-        b = '0000000000000000000000000001ffff'.decode('hex_codec')
+        b = binascii.unhexlify(b'0000000000000000000000000001ffff')
         t = ntoa6(b)
-        self.failUnless(t == '::0.1.255.255')
+        self.assertEqual(t, b'::0.1.255.255')
 
     def test_bad_ntoa1(self):
         def bad():
@@ -164,14 +165,14 @@ class NtoAAtoNTestCase(unittest.TestCase
         self.failUnlessRaises(ValueError, bad)
 
     def test_good_v4_aton(self):
-        pairs = [('1.2.3.4', '\x01\x02\x03\x04'),
-                 ('255.255.255.255', '\xff\xff\xff\xff'),
-                 ('0.0.0.0', '\x00\x00\x00\x00')]
+        pairs = [(b'1.2.3.4', b'\x01\x02\x03\x04'),
+                 (b'255.255.255.255', b'\xff\xff\xff\xff'),
+                 (b'0.0.0.0', b'\x00\x00\x00\x00')]
         for (t, b) in pairs:
             b1 = aton4(t)
             t1 = ntoa4(b1)
-            self.failUnless(b1 == b)
-            self.failUnless(t1 == t)
+            self.assertEqual(b1, b)
+            self.assertEqual(t1, t)
 
     def test_bad_v4_aton(self):
         def make_bad(a):
@@ -179,6 +180,7 @@ class NtoAAtoNTestCase(unittest.TestCase
                 return aton4(a)
             return bad
         for addr in v4_bad_addrs:
+            print(addr)
             self.failUnlessRaises(dns.exception.SyntaxError, make_bad(addr))
 
     def test_bad_v6_aton(self):
@@ -194,10 +196,10 @@ class NtoAAtoNTestCase(unittest.TestCase
             self.failUnlessRaises(dns.exception.SyntaxError, make_bad(addr))
 
     def test_rfc5952_section_4_2_2(self):
-        addr = '2001:db8:0:1:1:1:1:1'
+        addr = b'2001:db8:0:1:1:1:1:1'
         b1 = aton6(addr)
         t1 = ntoa6(b1)
-        self.failUnless(t1 == addr)
+        self.assertEqual(t1, addr)
 
     def test_is_mapped(self):
         t1 = '2001:db8:0:1:1:1:1:1'
Index: dnspython-1.12.0/tests/test_resolver.py
===================================================================
--- dnspython-1.12.0.orig/tests/test_resolver.py
+++ dnspython-1.12.0/tests/test_resolver.py
@@ -13,7 +13,7 @@
 # ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT
 # OF OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
 
-import cStringIO
+from io import StringIO
 import select
 import sys
 import time
@@ -25,8 +25,9 @@ import dns.name
 import dns.rdataclass
 import dns.rdatatype
 import dns.resolver
+from dns._compat import xrange
 
-resolv_conf = """
+resolv_conf = u"""
     /t/t
 # comment 1
 ; comment 2
@@ -55,7 +56,7 @@ class BaseResolverTests(object):
 
     if sys.platform != 'win32':
         def testRead(self):
-            f = cStringIO.StringIO(resolv_conf)
+            f = StringIO(resolv_conf)
             r = dns.resolver.Resolver(f)
             self.failUnless(r.nameservers == ['10.0.0.1', '10.0.0.2'] and
                             r.domain == dns.name.from_text('foo'))
Index: dnspython-1.12.0/tests/test_tokenizer.py
===================================================================
--- dnspython-1.12.0.orig/tests/test_tokenizer.py
+++ dnspython-1.12.0/tests/test_tokenizer.py
@@ -14,6 +14,10 @@
 # OF OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
 
 import unittest
+try:
+    import unittest2 as unittest
+except ImportError:
+    import unittest
 
 import dns.exception
 import dns.tokenizer
Index: dnspython-1.12.0/tests/test_update.py
===================================================================
--- dnspython-1.12.0.orig/tests/test_update.py
+++ dnspython-1.12.0/tests/test_update.py
@@ -18,6 +18,7 @@ import unittest
 import dns.update
 import dns.rdata
 import dns.rdataset
+import binascii
 
 goodhex = '0001 2800 0001 0005 0007 0000' \
           '076578616d706c6500 0006 0001' \
@@ -34,7 +35,7 @@ goodhex = '0001 2800 0001 0005 0007 0000
           '04626c617ac00c 0001 00ff 00000000 0000' \
           'c049 00ff 00ff 00000000 0000'
 
-goodwire = goodhex.replace(' ', '').decode('hex_codec')
+goodwire = binascii.unhexlify(goodhex.replace(' ', '').encode())
 
 update_text="""id 1
 opcode UPDATE
